/*
 * libm100simを使うサンプル
 *
 * 10/0/1/2/護速熱四重/たぬき vs. 5/0/0/3/祈詠柵増鏡押/無限鏡
 */

# include "match.h" /* シミュレータ本体 */

# include <stdio.h>
# include <stdlib.h>

int main(void)
{
  m100sim_match_options opts;
  m100sim_character tanuki, mugenkyo;

  /* 剣師の設定 */
  tanuki.name = "たぬき"; /* NULL可 */
  tanuki.hp = 10;
  tanuki.atk = 0;
  tanuki.def = 1;
  tanuki.spd = 2;
  tanuki.n_swords = 5; /* 剣の本数 */
  { /* 剣の設定 */
    m100sim_sword_ref *swords = (m100sim_sword_ref *)malloc(sizeof(m100sim_sword_ref) * 5);
    swords[0] = m100sim_s_protect; /* 護 */
    swords[1] = m100sim_s_accel;   /* 速 */
    swords[2] = m100sim_s_heat;    /* 熱 */
    swords[3] = m100sim_s_four;    /* 四 */
    swords[4] = m100sim_s_heavy;   /* 重 */
    tanuki.swords = swords;
  }

  mugenkyo.name = "無限鏡";
  mugenkyo.hp = 5;
  mugenkyo.atk = 0;
  mugenkyo.def = 0;
  mugenkyo.spd = 3;
  mugenkyo.n_swords = 6;
  {
    m100sim_sword_ref *swords = (m100sim_sword_ref *)malloc(sizeof(m100sim_sword_ref) * 6);
    swords[0] = m100sim_s_rogation;/* 祈 */
    swords[1] = m100sim_s_chantA;  /* 詠 (m100の詠唱剣とは別物なので'A') */
    swords[2] = m100sim_s_mkfence; /* 柵 */
    swords[3] = m100sim_s_multi;   /* 増 (m100の増殖剣と共通) */
    swords[4] = m100sim_s_mirror;  /* 鏡 */
    swords[5] = m100sim_s_pushA;   /* 押 */
    mugenkyo.swords = swords;
  }

  /* 対戦設定 */
  opts.log_output = stdout; /* ログ出力先。NULL可 */
  opts.line_terminator = "\n";

  switch(m100sim_match(opts, tanuki, mugenkyo)) /* 実行 */
  {
  case m100sim_left_wins:
    printf("左キャラ勝利!\n");
    break;
  case m100sim_right_wins:
    printf("右キャラ勝利!\n");
    break;
  case m100sim_draw:
    printf("引き分け!\n");
    break;
  case m100sim_aborted: /* 事故(主に整数オーバーフローの危険)により異常終了。m2011αルールでは普通発生しない */
    printf("謎エラー\n");
    break;
  }

  free((void *)tanuki.swords);
  free((void *)mugenkyo.swords);

  return 0;
}
